%define real_name rtl8192eu-linux

%global commit 6a6cf677a98c7afd9f3269f0a6edd9219b48852b
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global gitdate 20240529

Summary: Linux Driver for USB WiFi Adapters that are based on the RTL8811AU and RTL8821AU Chipsets
Name: dkms-rtl8192eu
Version: 5.11.2.1
Release: 5.git%{gitdate}%{?dist}
License: GPL-2.0-only
Group: System Environment/Kernel
URL: https://github.com/clnhub/rtl8192eu-linux
Source0: https://github.com/clnhub/rtl8192eu-linux/archive/%{commit}/rtl8192eu-linux-%{shortcommit}.tar.gz
Source1: rtl8xxxu-blacklist.conf
Source2: dkms-rtl8192eu.metainfo.xml
BuildArch: noarch
Requires: gcc
Requires: make
%if 0%{?el9}
Requires: kernel-devel >= 5.14.0-82
%else
Requires: kernel-devel
%endif
Requires: bc
Requires: kernel-modules
Requires(post): dkms
Requires(preun): dkms

%description
Linux Driver for USB WiFi Adapters that are based on the RTL8192EU Chipsets

%prep
%setup -q -n %{real_name}-%{commit}

%build

%install
%{__rm} -rf %{buildroot}

%__install -Dm0644 %{SOURCE1} -t %{buildroot}%{_sysconfdir}/modprobe.d

#install appstream metainfo
%__install -Dm0644 %{SOURCE2} -t %{buildroot}%{_metainfodir}

%define dkms_name 8192eu
%define dkms_vers %{version}-%{release}
%define quiet -q

# Kernel module sources install for dkms
%{__mkdir_p} %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{__cp} -a core hal include os_dep platform Makefile Kconfig %{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/

# Configuration for dkms
%{__cat} <<'EOF' >%{buildroot}%{_usrsrc}/%{dkms_name}-%{dkms_vers}/dkms.conf
PACKAGE_NAME=%{dkms_name}
PACKAGE_VERSION=%{dkms_vers}
MAKE[0]="'make' -j$(nproc) KVER=${kernelver}"
CLEAN[0]="'make' clean"
BUILT_MODULE_NAME[0]=%{dkms_name}
DEST_MODULE_LOCATION[0]=/kernel/drivers/net
AUTOINSTALL="YES"
EOF

%post
# Add to DKMS registry
dkms --rpm_safe_upgrade add -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
# Rebuild and make available for the currenty running kernel
dkms --rpm_safe_upgrade build -m %{dkms_name} -v %{dkms_vers} %{?quiet} || :
dkms --rpm_safe_upgrade install -m %{dkms_name} -v %{dkms_vers} %{?quiet} --force || :

%preun
# Remove all versions from DKMS registry
dkms --rpm_safe_upgrade remove -m %{dkms_name} -v %{dkms_vers} %{?quiet} --all || :

%files
%defattr(-, root, root, -)
%doc README.md
%{_usrsrc}/%{dkms_name}-%{dkms_vers}/
%{_sysconfdir}/modprobe.d/rtl8xxxu-blacklist.conf
%{_metainfodir}/*.metainfo.xml

%changelog
* Wed May 29 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20240529
- Improve kernel 6.8(+) support

* Fri Mar 29 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20240329
- Update README.md
- Add kernel 6.9(+) support

* Sat Feb 10 2024 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20240210
- Merge pull request #99 from clnhub/temp

* Thu Nov 30 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20231130
- Update README.md
- Add kernel 6.7(+) support

* Mon Sep 11 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20230911
- Update README.md
- Update README.md

* Thu Jun 22 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20230622
- Improve kernel 6.1(+) support
- Merge pull request #79 from BeetMacol/uninstall-script
- Update README.md

* Sun Mar 12 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20230312
- Merge pull request #76 from giuliobenetti/fix/powerpc64-build
- Merge pull request #75 from FlorianRemy/5.11.2.1

* Mon Mar 06 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20230306
- Update README.md
- Add kernel 6.3(+) support

* Thu Mar 02 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20230302
- Merge pull request #73 from sunwire/centos9

* Wed Mar 01 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-5.git20230212
- Add CentOS Stream 9.2 kernel support

* Sun Feb 12 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-4.git20230212
- Improve Red Hat 9.1 (kernel 5.14) support

* Sat Feb 11 2023 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-4.git20221229
- Add RHEL9.1 kernel support

* Thu Dec 29 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-3.git20221229
- Merge pull request #69 from giuliobenetti/fix/sha256
- Update README.md
- Update README.md

* Wed Nov 30 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-3.git20221130
- Merge pull request #65 from giuliobenetti/dev/move-user-extra-cflags-to-bottom
- Update README.md
- Update dkms.conf

* Sat Nov 12 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-3.git20221112
- Update dkms.conf
- Improve date/time support
- Update README.md
- Remove deprecated feature: REMAKE_INITRD
- Update README.md
- Improve MakeFile (ARM, debug)

* Mon Oct 17 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-3.git20221017
- Add kernel 6.1(+) support
- Update README.md

* Sat Oct 15 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-3.git20221015
- Improve kernel 5.6(+) support
- Improve kernel 5.15(+) support

* Sat Oct 15 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-2.git20221015
- Merge pull request #59 from jameshilliard/5.11.2.1-fix-dev-addr

* Fri Oct 14 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-2.git20221014
- Merge pull request #57 from jameshilliard/5.11.2.1-usbids

* Fri Oct 14 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.11.2.1-1.git20221014
- Udate to version 5.11.2.1

* Mon Oct 10 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.6.4-4.git20220820
- Update appstream metainfo file

* Mon Oct 10 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.6.4-3.git20220820
- Add appstream metainfo file

* Sat Aug 20 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.6.4-2.git20220820
- Update README.md
- Add kernel 6.0(+) support

* Thu Aug 18 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.6.4-2.git20220818
- Add kernel 5.19.2(+) support
- Update README.md

* Thu Apr 07 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.6.4-2.git20220407
- Update README.md
- Add kernel 5.18(+) support

* Tue Mar 1 2022 Paweł Marciniak <sunwire+repo@gmail.com> - 5.6.4-2.git20220202
- Blacklist rtl8xxxu module
